Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 4332)
@@ -43,5 +43,5 @@
    PUBLIC   lim_itd_me_alloc        ! called by iceini.F90
 
-   REAL(wp) ::   epsi11 = 1.e-11_wp   ! constant values
+   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
    REAL(wp) ::   epsi10 = 1.e-10_wp   ! constant values
    REAL(wp) ::   epsi06 = 1.e-06_wp   ! constant values
@@ -50,20 +50,18 @@
    ! Variables shared among ridging subroutines
    !-----------------------------------------------------------------------
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
-   !
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
-   !                                                           !  closing associated w/ category n
-   !
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hraft    ! thickness of rafted ice
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   krdg     ! mean ridge thickness/thickness of ridging ice 
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   aridge   ! participating ice ridging
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   araft    ! participating ice rafting
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
+   !                                                     ! closing associated w/ category n
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   hraft    ! thickness of rafted ice
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   krdg     ! mean ridge thickness/thickness of ridging ice 
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   aridge   ! participating ice ridging
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   araft    ! participating ice rafting
 
    REAL(wp), PARAMETER ::   krdgmin = 1.1_wp    ! min ridge thickness multiplier
    REAL(wp), PARAMETER ::   kraft   = 2.0_wp    ! rafting multipliyer
-   REAL(wp), PARAMETER ::   kamax   = 1.0
+   REAL(wp), PARAMETER ::   kamax   = 1.0_wp    ! max of ice area authorized (clem: scheme is not stable if kamax <= 0.99)
 
    REAL(wp) ::   Cp                             ! 
@@ -183,8 +181,4 @@
       ! 1) Thickness categories boundaries, ice / o.w. concentrations, init_ons
       !-----------------------------------------------------------------------------!
-      ! Set hi_max(ncat) to a big value to ensure that all ridged ice is thinner than hi_max(ncat).
-
-      hi_max(jpl) = 999.99
-
       Cp = 0.5 * grav * (rau0-rhoic) * rhoic / rau0                ! proport const for PE
       !
@@ -265,5 +259,5 @@
                ! Reduce the closing rate if more than 100% of the open water 
                ! would be removed.  Reduce the opening rate proportionately.
-               IF ( ato_i(ji,jj) .GT. epsi11 .AND. athorn(ji,jj,0) .GT. 0.0 ) THEN
+               IF ( ato_i(ji,jj) .GT. epsi10 .AND. athorn(ji,jj,0) .GT. 0.0 ) THEN
                   w1 = athorn(ji,jj,0) * closing_gross(ji,jj) * rdt_ice
                   IF ( w1 .GT. ato_i(ji,jj)) THEN
@@ -285,5 +279,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  IF ( a_i(ji,jj,jl) > epsi11 .AND. athorn(ji,jj,jl) > 0._wp )THEN
+                  IF ( a_i(ji,jj,jl) > epsi10 .AND. athorn(ji,jj,jl) > 0._wp )THEN
                      w1 = athorn(ji,jj,jl) * closing_gross(ji,jj) * rdt_ice
                      IF ( w1  >  a_i(ji,jj,jl) ) THEN
@@ -316,5 +310,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF (ABS(asum(ji,jj) - kamax ) .LT. epsi11) THEN
+               IF (ABS(asum(ji,jj) - kamax ) .LT. epsi10) THEN
                   closing_net(ji,jj) = 0._wp
                   opning     (ji,jj) = 0._wp
@@ -358,5 +352,5 @@
          DO ji = 1, jpi
 
-            IF(ABS(asum(ji,jj) - kamax) > epsi11 ) asum_error = .true.
+            IF(ABS(asum(ji,jj) - kamax) > epsi10 ) asum_error = .true.
 
             dardg1dt(ji,jj) = dardg1dt(ji,jj) * r1_rdtice
@@ -377,5 +371,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ABS( asum(ji,jj) - kamax)  >  epsi11 ) THEN   ! there is a bug
+            IF( ABS( asum(ji,jj) - kamax)  >  epsi10 ) THEN   ! there is a bug
                WRITE(numout,*) ' '
                WRITE(numout,*) ' ALERTE : Ridging error: total area = ', asum(ji,jj)
@@ -400,7 +394,6 @@
 
       !-----------------------------------------------------------------------------!
-      ! 6) Updating state variables and trend terms
+      ! 6) Updating state variables and trend terms (done in limupdate)
       !-----------------------------------------------------------------------------!
-
       CALL lim_var_glo2eqv
       CALL lim_itd_me_zapsmall
@@ -419,19 +412,4 @@
          END DO
       END DO
-
-      !-----------------
-      !  Trend terms
-      !-----------------
-
-      d_u_ice_dyn(:,:)     = u_ice(:,:)     - old_u_ice(:,:)
-      d_v_ice_dyn(:,:)     = v_ice(:,:)     - old_v_ice(:,:)
-      d_a_i_trp  (:,:,:)   = a_i  (:,:,:)   - old_a_i  (:,:,:)
-      d_v_s_trp  (:,:,:)   = v_s  (:,:,:)   - old_v_s  (:,:,:)  
-      d_v_i_trp  (:,:,:)   = v_i  (:,:,:)   - old_v_i  (:,:,:)   
-      d_e_s_trp  (:,:,:,:) = e_s  (:,:,:,:) - old_e_s  (:,:,:,:)  
-      d_e_i_trp  (:,:,:,:) = e_i  (:,:,:,:) - old_e_i  (:,:,:,:)
-      d_oa_i_trp (:,:,:)   = oa_i (:,:,:)   - old_oa_i (:,:,:)
-      d_smv_i_trp(:,:,:)   = 0._wp
-      IF(  num_sal == 2  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       IF(ln_ctl) THEN     ! Control print
@@ -491,64 +469,4 @@
       ! -------------------------------
 
-      !-------------------------!
-      ! Back to initial values
-      !-------------------------!
-
-      ! update of fields will be made later in lim update
-      u_ice(:,:)   = old_u_ice(:,:)
-      v_ice(:,:)   = old_v_ice(:,:)
-      a_i(:,:,:)   = old_a_i(:,:,:)
-      v_s(:,:,:)   = old_v_s(:,:,:)
-      v_i(:,:,:)   = old_v_i(:,:,:)
-      e_s(:,:,:,:) = old_e_s(:,:,:,:)
-      e_i(:,:,:,:) = old_e_i(:,:,:,:)
-      oa_i(:,:,:)  = old_oa_i(:,:,:)
-      IF(  num_sal == 2  )   smv_i(:,:,:) = old_smv_i(:,:,:)
-
-      !----------------------------------------------------!
-      ! Advection of ice in a free cell, newly ridged ice
-      !----------------------------------------------------!
-
-      ! to allow for thermodynamics to melt new ice
-      ! we immediately advect ice in free cells
-
-      ! heat content has to be corrected before ice volume
-!clem@order
-!      DO jl = 1, jpl
-!         DO jk = 1, nlay_i
-!            DO jj = 1, jpj
-!               DO ji = 1, jpi
-!                  IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-!                     ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-!                     old_e_i(ji,jj,jk,jl)   = d_e_i_trp(ji,jj,jk,jl)
-!                     d_e_i_trp(ji,jj,jk,jl) = 0._wp
-!                  ENDIF
-!               END DO
-!            END DO
-!         END DO
-!      END DO
-!
-!      DO jl = 1, jpl
-!         DO jj = 1, jpj
-!            DO ji = 1, jpi
-!               IF(  old_v_i  (ji,jj,jl) < epsi06  .AND. &
-!                    d_v_i_trp(ji,jj,jl) > epsi06    ) THEN
-!                  old_v_i   (ji,jj,jl)   = d_v_i_trp(ji,jj,jl)
-!                  d_v_i_trp (ji,jj,jl)   = 0._wp
-!                  old_a_i   (ji,jj,jl)   = d_a_i_trp(ji,jj,jl)
-!                  d_a_i_trp (ji,jj,jl)   = 0._wp
-!                  old_v_s   (ji,jj,jl)   = d_v_s_trp(ji,jj,jl)
-!                  d_v_s_trp (ji,jj,jl)   = 0._wp
-!                  old_e_s   (ji,jj,1,jl) = d_e_s_trp(ji,jj,1,jl)
-!                  d_e_s_trp (ji,jj,1,jl) = 0._wp
-!                  old_oa_i  (ji,jj,jl)   = d_oa_i_trp(ji,jj,jl)
-!                  d_oa_i_trp(ji,jj,jl)   = 0._wp
-!                  IF(  num_sal == 2  )   old_smv_i(ji,jj,jl) = d_smv_i_trp(ji,jj,jl)
-!                  d_smv_i_trp(ji,jj,jl)  = 0._wp
-!               ENDIF
-!            END DO
-!         END DO
-!      END DO
-!clem@order
       ENDIF  ! ln_limdyn=.true.
       !
@@ -605,6 +523,5 @@
                DO ji = 1, jpi
                   !
-                  IF(  a_i(ji,jj,jl)    > epsi11  .AND.     &
-                       athorn(ji,jj,jl) > 0._wp   ) THEN
+                  IF( a_i(ji,jj,jl) > epsi10 .AND. athorn(ji,jj,jl) > 0._wp ) THEN
                      hi = v_i(ji,jj,jl) / a_i(ji,jj,jl)
                      !----------------------------
@@ -624,5 +541,5 @@
                         * z1_3 * (hrmax(ji,jj,jl)**3 - hrmin(ji,jj,jl)**3) / ( hrmax(ji,jj,jl)-hrmin(ji,jj,jl) )   
 !!gm Optimization:  (a**3-b**3)/(a-b) = a*a+ab+b*b   ==> less costly operations even if a**3 is replaced by a*a*a...                    
-                  ENDIF            ! aicen > epsi11
+                  ENDIF            ! aicen > epsi10
                   !
                END DO ! ji
@@ -681,5 +598,5 @@
          DO jj = 2, jpj - 1
             DO ji = 2, jpi - 1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi11) THEN ! ice is
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi10) THEN ! ice is
                   ! present
                   zworka(ji,jj) = 4.0 * strength(ji,jj)              &
@@ -721,5 +638,5 @@
          DO jj = 1, jpj - 1
             DO ji = 1, jpi - 1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi11) THEN       ! ice is present
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) .GT. epsi10) THEN       ! ice is present
                   numts_rm = 1 ! number of time steps for the running mean
                   IF ( strp1(ji,jj) .GT. 0.0 ) numts_rm = numts_rm + 1
@@ -794,5 +711,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ato_i(ji,jj) > epsi11 ) THEN   ;   Gsum(ji,jj,0) = ato_i(ji,jj)
+            IF( ato_i(ji,jj) > epsi10 ) THEN   ;   Gsum(ji,jj,0) = ato_i(ji,jj)
             ELSE                               ;   Gsum(ji,jj,0) = 0._wp
             ENDIF
@@ -804,5 +721,5 @@
          DO jj = 1, jpj 
             DO ji = 1, jpi
-               IF( a_i(ji,jj,jl) .GT. epsi11 ) THEN   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1) + a_i(ji,jj,jl)
+               IF( a_i(ji,jj,jl) .GT. epsi10 ) THEN   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1) + a_i(ji,jj,jl)
                ELSE                                   ;   Gsum(ji,jj,jl) = Gsum(ji,jj,jl-1)
                ENDIF
@@ -887,10 +804,9 @@
       IF ( raftswi == 1 ) THEN
 
-         IF( MAXVAL(aridge + araft - athorn(:,:,1:jpl)) .GT. epsi11 ) THEN
+         IF( MAXVAL(aridge + araft - athorn(:,:,1:jpl)) .GT. epsi10 ) THEN
             DO jl = 1, jpl
                DO jj = 1, jpj
                   DO ji = 1, jpi
-                     IF ( aridge(ji,jj,jl) + araft(ji,jj,jl) - athorn(ji,jj,jl) .GT. &
-                        epsi11 ) THEN
+                     IF ( aridge(ji,jj,jl) + araft(ji,jj,jl) - athorn(ji,jj,jl) .GT. epsi10 ) THEN
                         WRITE(numout,*) ' ALERTE 96 : wrong participation function ... '
                         WRITE(numout,*) ' ji, jj, jl : ', ji, jj, jl
@@ -938,5 +854,5 @@
             DO ji = 1, jpi
 
-               IF (a_i(ji,jj,jl) .GT. epsi11 .AND. athorn(ji,jj,jl) .GT. 0.0 ) THEN
+               IF (a_i(ji,jj,jl) .GT. epsi10 .AND. athorn(ji,jj,jl) .GT. 0.0 ) THEN
                   hi = v_i(ji,jj,jl) / a_i(ji,jj,jl)
                   hrmean          = MAX(SQRT(Hstar*hi), hi*krdgmin)
@@ -992,5 +908,5 @@
       INTEGER ::   ij                ! horizontal index, combines i and j loops
       INTEGER ::   icells            ! number of cells with aicen > puny
-      REAL(wp) ::   zeps, zindb, zsrdg2   ! local scalar
+      REAL(wp) ::   zindb, zsrdg2   ! local scalar
       REAL(wp) ::   hL, hR, farea, zdummy, zdummy0, ztmelts    ! left and right limits of integration
 
@@ -1044,11 +960,13 @@
 
       IF( con_i ) THEN
-         CALL lim_column_sum (jpl,   v_i, vice_init )
-         WRITE(numout,*) ' vice_init  : ', vice_init(jiindx,jjindx)
+         CALL lim_column_sum        (jpl,    v_i,       vice_init )
          CALL lim_column_sum_energy (jpl, nlay_i,  e_i, eice_init )
-         WRITE(numout,*) ' eice_init  : ', eice_init(jiindx,jjindx)
+         DO ji = mi0(jiindx), mi1(jiindx)
+            DO jj = mj0(jjindx), mj1(jjindx)
+               WRITE(numout,*) ' vice_init  : ', vice_init(ji,jj)
+               WRITE(numout,*) ' eice_init  : ', eice_init(ji,jj)
+            END DO
+         END DO
       ENDIF
-
-      zeps   = 1.e-20_wp
 
       !-------------------------------------------------------------------------------
@@ -1062,5 +980,5 @@
             ato_i(ji,jj) = ato_i(ji,jj) - athorn(ji,jj,0) * closing_gross(ji,jj) * rdt_ice        &
                &                        + opning(ji,jj)                          * rdt_ice
-            IF( ato_i(ji,jj) < -epsi11 ) THEN
+            IF( ato_i(ji,jj) < -epsi10 ) THEN
                neg_ato_i = .TRUE.
             ELSEIF( ato_i(ji,jj) < 0._wp ) THEN    ! roundoff error
@@ -1074,9 +992,9 @@
          DO jj = 1, jpj 
             DO ji = 1, jpi
-               IF( ato_i(ji,jj) < -epsi11 ) THEN 
+               IF( ato_i(ji,jj) < -epsi10 ) THEN 
                   WRITE(numout,*) ''  
                   WRITE(numout,*) 'Ridging error: ato_i < 0'
                   WRITE(numout,*) 'ato_i : ', ato_i(ji,jj)
-               ENDIF               ! ato_i < -epsi11
+               ENDIF               ! ato_i < -epsi10
             END DO
          END DO
@@ -1120,6 +1038,6 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF( aicen_init(ji,jj,jl1)  >  epsi11  .AND.  athorn(ji,jj,jl1)  >  0._wp       &
-                  .AND. closing_gross(ji,jj) > 0._wp ) THEN
+               IF( aicen_init(ji,jj,jl1) > epsi10 .AND. athorn(ji,jj,jl1) > 0._wp  &
+                  &   .AND. closing_gross(ji,jj) > 0._wp ) THEN
                   icells = icells + 1
                   indxi(icells) = ji
@@ -1158,10 +1076,10 @@
             afrft(ji,jj) = arft1(ji,jj) / aicen_init(ji,jj,jl1) !rafting
 
-            IF (afrac(ji,jj) > kamax + epsi11) THEN  !riging
+            IF (afrac(ji,jj) > kamax + epsi10) THEN  !riging
                large_afrac = .true.
             ELSEIF (afrac(ji,jj) > kamax) THEN  ! roundoff error
                afrac(ji,jj) = kamax
             ENDIF
-            IF (afrft(ji,jj) > kamax + epsi11) THEN !rafting
+            IF (afrft(ji,jj) > kamax + epsi10) THEN !rafting
                large_afrft = .true.
             ELSEIF (afrft(ji,jj) > kamax) THEN  ! roundoff error
@@ -1222,5 +1140,4 @@
             dardg1dt   (ji,jj) = dardg1dt(ji,jj) + ardg1(ji,jj) + arft1(ji,jj)
             dardg2dt   (ji,jj) = dardg2dt(ji,jj) + ardg2(ji,jj) + arft2(ji,jj)
-            !clem diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) * r1_rdtice
             opening    (ji,jj) = opening (ji,jj) + opning(ji,jj) * rdt_ice
 
@@ -1276,6 +1193,6 @@
 
                ! corrected sea water salinity
-               zindb  = MAX( 0._wp , SIGN( 1._wp , vsw(ji,jj) - zeps ) )
-               zdummy = zindb * ( srdg1(ji,jj) - srdg2(ji,jj) ) / MAX( ridge_por * vsw(ji,jj), zeps )
+               zindb  = MAX( 0._wp , SIGN( 1._wp , vsw(ji,jj) - epsi20 ) )
+               zdummy = zindb * ( srdg1(ji,jj) - srdg2(ji,jj) ) / MAX( ridge_por * vsw(ji,jj), epsi20 )
 
                ztmelts          = - tmut * zdummy + rtt
@@ -1312,5 +1229,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrac(ji,jj) > kamax + epsi11 ) THEN 
+               IF( afrac(ji,jj) > kamax + epsi10 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' ardg > a_i'
@@ -1324,5 +1241,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrft(ji,jj) > kamax + epsi11 ) THEN 
+               IF( afrft(ji,jj) > kamax + epsi10 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' arft > a_i'
@@ -1424,12 +1341,17 @@
          fieldid = ' v_i : limitd_me '
          CALL lim_cons_check (vice_init, vice_final, 1.0e-6, fieldid) 
-         WRITE(numout,*) ' vice_init  : ', vice_init(jiindx,jjindx)
-         WRITE(numout,*) ' vice_final : ', vice_final(jiindx,jjindx)
 
          CALL lim_column_sum_energy (jpl, nlay_i,  e_i, eice_final )
          fieldid = ' e_i : limitd_me '
          CALL lim_cons_check (eice_init, eice_final, 1.0e-2, fieldid) 
-         WRITE(numout,*) ' eice_init  : ', eice_init(jiindx,jjindx)
-         WRITE(numout,*) ' eice_final : ', eice_final(jiindx,jjindx)
+
+         DO ji = mi0(jiindx), mi1(jiindx)
+            DO jj = mj0(jjindx), mj1(jjindx)
+               WRITE(numout,*) ' vice_init  : ', vice_init (ji,jj)
+               WRITE(numout,*) ' vice_final : ', vice_final(ji,jj)
+               WRITE(numout,*) ' eice_init  : ', eice_init (ji,jj)
+               WRITE(numout,*) ' eice_final : ', eice_final(ji,jj)
+            END DO
+         END DO
       ENDIF
       !
@@ -1533,5 +1455,5 @@
 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zmask   ! 2D workspace
-      
+      REAL(wp)                          ::   zmask_glo
 !!gm      REAL(wp) ::   xtmp      ! temporary variable
       !!-------------------------------------------------------------------
@@ -1545,27 +1467,16 @@
          ! Abort model in case of negative area.
          !-----------------------------------------------------------------
-         IF( MINVAL(a_i(:,:,jl)) .LT. -epsi11 .AND. ln_nicep ) THEN
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF ( a_i(ji,jj,jl) .LT. -epsi11 ) THEN
-                     WRITE (numout,*) ' ALERTE 98 ' 
-                     WRITE (numout,*) ' Negative ice area: ji, jj, jl: ', ji, jj,jl
-                     WRITE (numout,*) ' a_i    ', a_i(ji,jj,jl)
-                  ENDIF
-               END DO
-            END DO
-         ENDIF
-
          icells = 0
-         zmask  = 0._wp
+         zmask(:,:)  = 0._wp
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF(  ( a_i(ji,jj,jl) .GE. -epsi11 .AND. a_i(ji,jj,jl) .LT. 0._wp   ) .OR.   &
-                  & ( a_i(ji,jj,jl) .GT. 0._wp   .AND. a_i(ji,jj,jl) .LE. 1.0e-11 ) .OR.   &
-                  & ( v_i(ji,jj,jl)  ==  0._wp   .AND. a_i(ji,jj,jl) .GT. 0._wp   ) .OR.   &
-                  & ( v_i(ji,jj,jl) .GT. 0._wp   .AND. v_i(ji,jj,jl) .LT. 1.e-12  )      )   zmask(ji,jj) = 1._wp
-            END DO
-         END DO
-         IF( ln_nicep )   WRITE(numout,*) SUM(zmask), ' cells of ice zapped in the ocean '
+               IF(  ( a_i(ji,jj,jl) >= -epsi10 .AND. a_i(ji,jj,jl) <  0._wp   ) .OR.   &
+                  & ( a_i(ji,jj,jl) >  0._wp   .AND. a_i(ji,jj,jl) <= epsi10  ) .OR.   &
+                  & ( v_i(ji,jj,jl) == 0._wp   .AND. a_i(ji,jj,jl) >  0._wp   ) .OR.   &
+                  & ( v_i(ji,jj,jl) >  0._wp   .AND. v_i(ji,jj,jl) <= epsi10  ) )   zmask(ji,jj) = 1._wp
+            END DO
+         END DO
+         zmask_glo = glob_sum(zmask)
+         !IF( ln_nicep .AND. lwp ) WRITE(numout,*) zmask_glo, ' cells of ice zapped in the ocean '
 
          !-----------------------------------------------------------------
@@ -1579,5 +1490,5 @@
 !!gm                  xtmp = xtmp * unit_fac
                   ! fheat_res(ji,jj) = fheat_res(ji,jj) - xtmp
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * ( 1 - zmask(ji,jj) )
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * ( 1._wp - zmask(ji,jj) )
                END DO
             END DO
@@ -1601,5 +1512,5 @@
 !!gm               xtmp = ( rhosn*cpic*( rtt-t_s(ji,jj,1,jl) ) + rhosn*lfus ) * r1_rdtice !RB   ???????
 
-               t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1 - zmask(ji,jj) )
+               t_s(ji,jj,1,jl) = rtt * zmask(ji,jj) + t_s(ji,jj,1,jl) * ( 1._wp - zmask(ji,jj) )
 
                !-----------------------------------------------------------------
@@ -1615,10 +1526,10 @@
 
                ato_i(ji,jj)    = a_i  (ji,jj,jl) *       zmask(ji,jj)   + ato_i(ji,jj)
-               a_i  (ji,jj,jl) = a_i  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               v_i  (ji,jj,jl) = v_i  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               v_s  (ji,jj,jl) = v_s  (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               t_su (ji,jj,jl) = t_su (ji,jj,jl) * ( 1 - zmask(ji,jj) ) + t_bo(ji,jj) * zmask(ji,jj)
-               oa_i (ji,jj,jl) = oa_i (ji,jj,jl) * ( 1 - zmask(ji,jj) )
-               smv_i(ji,jj,jl) = smv_i(ji,jj,jl) * ( 1 - zmask(ji,jj) )
+               a_i  (ji,jj,jl) = a_i  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               v_i  (ji,jj,jl) = v_i  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               v_s  (ji,jj,jl) = v_s  (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               t_su (ji,jj,jl) = t_su (ji,jj,jl) * ( 1._wp - zmask(ji,jj) ) + t_bo(ji,jj) * zmask(ji,jj)
+               oa_i (ji,jj,jl) = oa_i (ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
+               smv_i(ji,jj,jl) = smv_i(ji,jj,jl) * ( 1._wp - zmask(ji,jj) )
                !
             END DO
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 4220)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 4332)
@@ -45,7 +45,6 @@
    PUBLIC   lim_itd_shiftice
 
-   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
-   REAL(wp) ::   epsi13 = 1.e-13_wp   !
    REAL(wp) ::   epsi10 = 1.e-10_wp   !
+   REAL(wp) ::   epsi06 = 1.e-6_wp   !
 
    !!----------------------------------------------------------------------
@@ -110,22 +109,5 @@
       CALL lim_var_glo2eqv    ! only for info
 
-      !----------------------------------------------------------------------------------------
-      !  4) Computation of trend terms and get back to old values      
-      !----------------------------------------------------------------------------------------
-
-      !- Trend terms
-      d_a_i_thd(:,:,:)   = a_i(:,:,:)   - old_a_i(:,:,:) 
-      d_v_s_thd(:,:,:)   = v_s(:,:,:)   - old_v_s(:,:,:)
-      d_v_i_thd(:,:,:)   = v_i(:,:,:)   - old_v_i(:,:,:)  
-      d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
-      d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
-      !?? d_oa_i_thd(:,:,:)  = oa_i (:,:,:) - old_oa_i (:,:,:)
-      d_smv_i_thd(:,:,:) = 0._wp
-      IF( num_sal == 2 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
-
-      ! diag only (clem)
-      dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) * r1_rdtice * rday
-
-      IF(ln_ctl) THEN   ! Control print
+     IF(ln_ctl) THEN   ! Control print
          CALL prt_ctl_info(' ')
          CALL prt_ctl_info(' - Cell values : ')
@@ -183,14 +165,5 @@
       ! -------------------------------
       !
-      !- Recover Old values
-      a_i(:,:,:)   = old_a_i (:,:,:)
-      v_s(:,:,:)   = old_v_s (:,:,:)
-      v_i(:,:,:)   = old_v_i (:,:,:)
-      e_s(:,:,:,:) = old_e_s (:,:,:,:)
-      e_i(:,:,:,:) = old_e_i (:,:,:,:)
-      !?? oa_i(:,:,:)  = old_oa_i(:,:,:)
-      IF( num_sal == 2 )   smv_i(:,:,:) = old_smv_i(:,:,:)
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('limitd_th')
+     IF( nn_timing == 1 )  CALL timing_stop('limitd_th')
    END SUBROUTINE lim_itd_th
    !
@@ -281,9 +254,9 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-a_i(ji,jj,jl)+epsi10))     !0 if no ice and 1 if yes
-               ht_i(ji,jj,jl)    = v_i(ji,jj,jl) / MAX(a_i(ji,jj,jl),epsi10) * zindb
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-old_a_i(ji,jj,jl)+epsi10)) !0 if no ice and 1 if yes
-               zht_i_o(ji,jj,jl) = old_v_i(ji,jj,jl) / MAX(old_a_i(ji,jj,jl),epsi10) * zindb
-               IF( a_i(ji,jj,jl) > 1e-6 )   zdhice(ji,jj,jl) = ht_i(ji,jj,jl) - zht_i_o(ji,jj,jl) 
+               zindb             = 1.0 - MAX( 0.0, SIGN( 1.0, - a_i(ji,jj,jl) + epsi10 ) )     !0 if no ice and 1 if yes
+               ht_i(ji,jj,jl)    = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb
+               zindb             = 1.0 - MAX( 0.0, SIGN( 1.0, - old_a_i(ji,jj,jl) + epsi10) ) !0 if no ice and 1 if yes
+               zht_i_o(ji,jj,jl) = old_v_i(ji,jj,jl) / MAX( old_a_i(ji,jj,jl), epsi10 ) * zindb
+               IF( a_i(ji,jj,jl) > epsi06 )   zdhice(ji,jj,jl) = ht_i(ji,jj,jl) - zht_i_o(ji,jj,jl) 
             END DO
          END DO
@@ -321,5 +294,5 @@
       ! Tricky trick see limitd_me.F90
       ! will be soon removed, CT
-      ! hi_max(kubnd) = 999.99
+      ! hi_max(kubnd) = 99.
       zhbnew(:,:,:) = 0._wp
 
@@ -329,6 +302,6 @@
             ij = nind_j(ji)
             !
-            IF ( ( zht_i_o(ii,ij,jl)  .GT.epsi10 ) .AND. & 
-               ( zht_i_o(ii,ij,jl+1).GT.epsi10 ) ) THEN
+            IF ( ( zht_i_o(ii,ij,jl) .GT. epsi10 ) .AND. & 
+               ( zht_i_o(ii,ij,jl+1) .GT. epsi10 ) ) THEN
                !interpolate between adjacent category growth rates
                zslope = ( zdhice(ii,ij,jl+1)     - zdhice(ii,ij,jl) ) / &
@@ -402,5 +375,7 @@
                zhbnew(ji,jj,kubnd) = 3._wp * ht_i(ji,jj,kubnd) - 2._wp * zhbnew(ji,jj,kubnd-1)
             ELSE
-               zhbnew(ji,jj,kubnd) = hi_max(kubnd)
+               zhbnew(ji,jj,kubnd) = hi_max(kubnd)  
+               !!? clem bug: since hi_max(jpl)=99, this limit is very high 
+               !!? but I think it is erased in fitline subroutine 
             ENDIF
 
@@ -447,5 +422,5 @@
                      * a_i(ii,ij,klbnd) / ( a_i(ii,ij,klbnd) - zda0 )
                   a_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd) - zda0
-                  v_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd)*ht_i(ii,ij,klbnd) ! clem@useless ?
+                  v_i(ii,ij,klbnd)  = a_i(ii,ij,klbnd)*ht_i(ii,ij,klbnd) ! clem-useless ?
                ENDIF     ! zetamax > 0
                ! ji, a_i > epsi10
@@ -539,5 +514,5 @@
             a_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) / hiclim 
             ht_i(ii,ij,1) = hiclim
-            v_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) !clem@useless
+            v_i(ii,ij,1)  = a_i(ii,ij,1) * ht_i(ii,ij,1) !clem-useless
          ENDIF
       END DO !ji
@@ -602,13 +577,11 @@
       REAL(wp) ::   zdhr         ! 1 / (hR - hL)
       REAL(wp) ::   zwk1, zwk2   ! temporary variables
-      REAL(wp) ::   zacrith      ! critical minimum concentration in an ice category
-      !!------------------------------------------------------------------
-      !
-      zacrith       = 1.0e-6
+      !!------------------------------------------------------------------
+      !
       !
       DO jj = 1, jpj
          DO ji = 1, jpi
             !
-            IF( zremap_flag(ji,jj) == 1 .AND. a_i(ji,jj,num_cat) > zacrith   &
+            IF( zremap_flag(ji,jj) == 1 .AND. a_i(ji,jj,num_cat) > epsi10   &
                &                        .AND. hice(ji,jj)        > 0._wp     ) THEN
 
@@ -1009,7 +982,10 @@
                   !zdaice(ji,jj,jl)  = a_i(ji,jj,jl)
                   !zdvice(ji,jj,jl)  = v_i(ji,jj,jl)
-                  zdaice(ji,jj,jl)  = a_i(ji,jj,jl)/2
-                  zdvice(ji,jj,jl)  = v_i(ji,jj,jl)-zdaice(ji,jj,jl)*(hi_max(jl)+hi_max(jl-1))/2
+                  !zdaice(ji,jj,jl)  = a_i(ji,jj,jl) * 0.5_wp
+                  !zdvice(ji,jj,jl)  = v_i(ji,jj,jl)-zdaice(ji,jj,jl)*(hi_max(jl)+hi_max(jl-1)) * 0.5_wp
                   ! end TECLIM change 
+                  ! clem: how much of a_i you send in cat sup is somewhat arbitrary
+                  zdaice(ji,jj,jl)  = a_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - hi_max(jl) + epsi10 ) / ht_i(ji,jj,jl)  
+                  zdvice(ji,jj,jl)  = v_i(ji,jj,jl) - ( a_i(ji,jj,jl) - zdaice(ji,jj,jl) ) * ( hi_max(jl) - epsi10 )
                ENDIF
             END DO                 ! ji
@@ -1038,26 +1014,40 @@
          zshiftflag = 0
 
+!clem-change
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               IF( a_i(ji,jj,jl+1) >  epsi10 .AND.   &
+!                  ht_i(ji,jj,jl+1) <= hi_max(jl) ) THEN
+!                  !
+!                  zshiftflag = 1
+!                  zdonor(ji,jj,jl) = jl + 1
+!                  zdaice(ji,jj,jl) = a_i(ji,jj,jl+1) 
+!                  zdvice(ji,jj,jl) = v_i(ji,jj,jl+1)
+!               ENDIF
+!            END DO                 ! ji
+!         END DO                 ! jj
+!
+!         IF(lk_mpp)   CALL mpp_max( zshiftflag )
+!         
+!         IF( zshiftflag == 1 ) THEN            ! Shift ice between categories
+!            CALL lim_itd_shiftice( klbnd, kubnd, zdonor, zdaice, zdvice )
+!            ! Reset shift parameters
+!            zdonor(:,:,jl) = 0
+!            zdaice(:,:,jl) = 0._wp
+!            zdvice(:,:,jl) = 0._wp
+!         ENDIF
+!clem-change
+
+         ! clem-change begin: why not doing that?
          DO jj = 1, jpj
             DO ji = 1, jpi
                IF( a_i(ji,jj,jl+1) >  epsi10 .AND.   &
                   ht_i(ji,jj,jl+1) <= hi_max(jl) ) THEN
-                  !
-                  zshiftflag = 1
-                  zdonor(ji,jj,jl) = jl + 1
-                  zdaice(ji,jj,jl) = a_i(ji,jj,jl+1) 
-                  zdvice(ji,jj,jl) = v_i(ji,jj,jl+1)
+                  ht_i(ji,jj,jl+1) = hi_max(jl) + epsi10
+                  a_i (ji,jj,jl+1) = v_i(ji,jj,jl+1) / ht_i(ji,jj,jl+1) 
                ENDIF
             END DO                 ! ji
          END DO                 ! jj
-
-         IF(lk_mpp)   CALL mpp_max( zshiftflag )
-         
-         IF( zshiftflag == 1 ) THEN            ! Shift ice between categories
-            CALL lim_itd_shiftice( klbnd, kubnd, zdonor, zdaice, zdvice )
-            ! Reset shift parameters
-            zdonor(:,:,jl) = 0
-            zdaice(:,:,jl) = 0._wp
-            zdvice(:,:,jl) = 0._wp
-         ENDIF
+         ! clem-change end
 
       END DO                    ! jl
